Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters.cpp	(revision 88)
@@ -22,5 +22,6 @@
 			  uint32_t nb_instruction               ,
 			  uint32_t size_branch_update_prediction,
-			  uint32_t size_general_data            )
+			  uint32_t size_general_data            ,
+                          bool     is_toplevel)
   {
     log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");
@@ -28,15 +29,23 @@
     _size_queue                            = size_queue                   ;
     _nb_instruction                        = nb_instruction               ;
-    _size_branch_update_prediction         = size_branch_update_prediction;
-    _size_general_data                     = size_general_data            ;
+//  _size_branch_update_prediction         = size_branch_update_prediction;
+//  _size_general_data                     = size_general_data            ;
 
-    _size_queue_ptr                        = log2(size_queue);
-    _size_instruction_ptr                  = log2(nb_instruction);
+    test();
 
-    _have_port_queue_ptr                   = _size_queue_ptr > 0;
-    _have_port_instruction_ptr             = _size_instruction_ptr > 0;
-    _have_port_branch_update_prediction_id = size_branch_update_prediction > 0;
-    
-    test();
+    if (is_toplevel)
+      {
+        _size_instruction_address   = size_general_data;
+        _size_ifetch_queue_ptr      = log2(size_queue);
+        _size_inst_ifetch_ptr       = log2(nb_instruction);
+        _size_depth                 = size_branch_update_prediction;
+
+        _have_port_ifetch_queue_ptr = _size_ifetch_queue_ptr > 0;
+        _have_port_inst_ifetch_ptr  = _size_inst_ifetch_ptr > 0;
+        _have_port_depth            = _size_depth > 0;
+
+        copy ();
+      }
+
     log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
   };
@@ -59,4 +68,12 @@
   };
 
+#undef  FUNCTION
+#define FUNCTION "Ifetch_queue::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Ifetch_queue,FUNCTION,"Begin");
+    log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
+  };
+
 }; // end namespace ifetch_queue
 }; // end namespace ifetch_unit
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters_msg_error.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters_msg_error.cpp	(revision 88)
@@ -28,15 +28,6 @@
 
     if (_size_queue == 1)
-      test.warning("To best perfomance, size_queue must be > 1.");
+      test.warning("To best perfomance, size_queue must be > 1.\n");
     
-//     if (not _have_port_queue_ptr)
-//       test.information("They have not port '..._QUEUE_PTR'.");
-
-//     if (not _have_port_instruction_ptr)
-//       test.information("They have not port '..._INST_IFETCH_PTR'.");
-
-//     if (not _have_port_branch_update_prediction_id)
-//       test.information("They have not port '..._BRANCH_UPDATE_PREDICTION_ID'.");
-
     log_printf(FUNC,Ifetch_queue,FUNCTION,"End");
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Parameters_print.cpp	(revision 88)
@@ -29,6 +29,6 @@
     xml.singleton_begin("size_queue                   "); xml.attribut("value",toString(_size_queue                   )); xml.singleton_end();
     xml.singleton_begin("nb_instruction               "); xml.attribut("value",toString(_nb_instruction               )); xml.singleton_end();
-    xml.singleton_begin("size_branch_update_prediction"); xml.attribut("value",toString(_size_branch_update_prediction)); xml.singleton_end();
-    xml.singleton_begin("size_general_data            "); xml.attribut("value",toString(_size_general_data            )); xml.singleton_end();
+//  xml.singleton_begin("size_branch_update_prediction"); xml.attribut("value",toString(_size_branch_update_prediction)); xml.singleton_end();
+//  xml.singleton_begin("size_general_data            "); xml.attribut("value",toString(_size_general_data            )); xml.singleton_end();
     xml.balise_close();
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Ifetch_unit_Glue_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/src/main.cpp	(revision 88)
@@ -37,5 +37,7 @@
     {
       morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::ifetch_unit_glue::Parameters * param = new morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::ifetch_unit_glue::Parameters
-	(_size_address);
+	(_size_address,
+         true //is_toplevel
+         );
       
       msg(_("%s"),param->print(1).c_str());
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/SelfTest/src/test.cpp	(revision 88)
@@ -23,4 +23,14 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Ifetch_unit_Glue * _Ifetch_unit_Glue = new Ifetch_unit_Glue 
     (name.c_str(),
@@ -29,5 +39,5 @@
 #endif
      _param,
-     USE_ALL);
+     _usage);
   
 #ifdef SYSTEMC
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/include/Parameters.h	(revision 88)
@@ -24,10 +24,13 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : uint32_t _size_address;
+//public : uint32_t _size_address;
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t size_address);
+  public : Parameters  (uint32_t size_address,
+                        bool     is_toplevel=false);
 //   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue.cpp	(revision 88)
@@ -38,4 +38,10 @@
     log_printf(FUNC,Ifetch_unit_Glue,FUNCTION,"Begin");
 
+#if DEBUG_Ifetch_unit_Glue == true
+    log_printf(INFO,Ifetch_unit_Glue,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     log_printf(INFO,Ifetch_unit_Glue,FUNCTION,"Allocation");
 
@@ -47,5 +53,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {	
 	log_printf(INFO,Ifetch_unit_Glue,FUNCTION,"Allocation of statistics");
@@ -56,5 +62,5 @@
 
 #ifdef VHDL
-    if (_usage & USE_VHDL)
+    if (usage_is_set(_usage,USE_VHDL))
       {
 	// generate the vhdl
@@ -66,8 +72,9 @@
 
 #ifdef SYSTEMC
-    PORT_WRITE(out_ICACHE_REQ_TYPE,ICACHE_TYPE_LOAD);
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+        // Write constant
+        PORT_WRITE(out_ICACHE_REQ_TYPE,ICACHE_TYPE_LOAD);
 
-    if (_usage & USE_SYSTEMC)
-      {
 # if defined(STATISTICS) or defined(VHDL_TESTBENCH)
 	log_printf(INFO,Ifetch_unit_Glue,FUNCTION,"Method - transition");
@@ -140,5 +147,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))  
       {
 	statistics_deallocation();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_allocation.cpp	(revision 88)
@@ -67,7 +67,7 @@
       ALLOC_SIGNAL_IN ( in_ICACHE_REQ_QUEUE_ACK      ,"queue_ack"      ,Tcontrol_t,1);
       ALLOC_SIGNAL_OUT(out_ICACHE_REQ_TYPE           ,"type"           ,Ticache_type_t,_param->_size_icache_type);
-      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_ADDRESS        ,"address"        ,Taddress_t,_param->_size_address);
-      ALLOC_SIGNAL_IN ( in_ICACHE_REQ_ADDRESS_ADDRESS,"address_address",Taddress_t,_param->_size_address);
-      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_QUEUE_ADDRESS  ,"queue_address"  ,Taddress_t,_param->_size_address);
+      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_ADDRESS        ,"address"        ,Taddress_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_IN ( in_ICACHE_REQ_ADDRESS_ADDRESS,"address_address",Taddress_t,_param->_size_instruction_address);
+      ALLOC_SIGNAL_OUT(out_ICACHE_REQ_QUEUE_ADDRESS  ,"queue_address"  ,Taddress_t,_param->_size_instruction_address);
     }
 
@@ -87,5 +87,6 @@
 
 #ifdef POSITION
-    _component->generate_file();
+     if (usage_is_set(_usage,USE_POSITION))
+       _component->generate_file();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_deallocation.cpp	(revision 88)
@@ -23,5 +23,5 @@
     log_printf(FUNC,Ifetch_unit_Glue,FUNCTION,"Begin");
 
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	delete     in_CLOCK ;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Ifetch_unit_Glue_end_cycle.cpp	(revision 88)
@@ -25,5 +25,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -31,5 +32,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Parameters.cpp	(revision 88)
@@ -19,11 +19,18 @@
 #undef  FUNCTION
 #define FUNCTION "Ifetch_unit_Glue::Parameters"
-  Parameters::Parameters (uint32_t size_address)
+  Parameters::Parameters (uint32_t size_address,
+                          bool     is_toplevel)
   {
     log_printf(FUNC,Ifetch_unit_Glue,FUNCTION,"Begin");
 
-    _size_address = size_address;
+    test();
 
-    test();
+    if (is_toplevel)
+      {
+        _size_instruction_address = size_address;
+
+        copy ();
+      }
+
     log_printf(FUNC,Ifetch_unit_Glue,FUNCTION,"End");
   };
@@ -46,4 +53,12 @@
   };
 
+#undef  FUNCTION
+#define FUNCTION "Ifetch_unit_Glue::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Ifetch_unit_Glue,FUNCTION,"Begin");
+    log_printf(FUNC,Ifetch_unit_Glue,FUNCTION,"End");
+  };
+
 }; // end namespace ifetch_unit_glue
 }; // end namespace ifetch_unit
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_unit_Glue/src/Parameters_print.cpp	(revision 88)
@@ -27,5 +27,5 @@
 
     xml.balise_open("ifetch_unit_glue");
-    xml.singleton_begin("size_address"); xml.attribut("value",toString(_size_address)); xml.singleton_end();
+//  xml.singleton_begin("size_address"); xml.attribut("value",toString(_size_address)); xml.singleton_end();
     xml.balise_close();
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Ifetch_unit_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/src/main.cpp	(revision 88)
@@ -47,5 +47,7 @@
 	 _nb_instruction                ,
 	 _size_branch_update_prediction ,
-	 _size_general_data             );
+	 _size_general_data             ,
+         true // is_toplevel
+         );
       
       msg(_("%s"),param->print(1).c_str());
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/SelfTest/src/test.cpp	(revision 88)
@@ -7,5 +7,5 @@
  */
 
-#define NB_ITERATION  128
+#define NB_ITERATION  1024
 #define CYCLE_MAX     (128*NB_ITERATION)
 
@@ -40,4 +40,13 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+  _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Ifetch_unit * _Ifetch_unit = new Ifetch_unit 
     (name.c_str(),
@@ -46,5 +55,5 @@
 #endif
      _param,
-     USE_ALL);
+     _usage);
   
 #ifdef SYSTEMC
@@ -92,4 +101,7 @@
   ALLOC_SC_SIGNAL (out_EVENT_ACK                          ,"out_EVENT_ACK                          ",Tcontrol_t           );
   ALLOC_SC_SIGNAL ( in_EVENT_ADDRESS                      ," in_EVENT_ADDRESS                      ",Tgeneral_address_t   );
+  ALLOC_SC_SIGNAL ( in_EVENT_ADDRESS_NEXT                 ," in_EVENT_ADDRESS_NEXT                 ",Tgeneral_address_t   );
+  ALLOC_SC_SIGNAL ( in_EVENT_ADDRESS_NEXT_VAL             ," in_EVENT_ADDRESS_NEXT_VAL             ",Tcontrol_t           );
+  ALLOC_SC_SIGNAL ( in_EVENT_IS_DS_TAKE                   ," in_EVENT_IS_DS_TAKE                   ",Tcontrol_t           );
   
   /********************************************************
@@ -105,5 +117,5 @@
   INSTANCE_SC_SIGNAL (_Ifetch_unit, in_ICACHE_REQ_ACK                     );
 //INSTANCE_SC_SIGNAL (_Ifetch_unit,out_ICACHE_REQ_THREAD_ID               );
-  if (_param->_have_port_queue_ptr)
+  if (_param->_have_port_ifetch_queue_ptr)
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_ICACHE_REQ_PACKET_ID               );
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_ICACHE_REQ_ADDRESS                 );
@@ -112,5 +124,5 @@
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_ICACHE_RSP_ACK                     );
 //INSTANCE_SC_SIGNAL (_Ifetch_unit, in_ICACHE_RSP_THREAD_ID               );
-  if (_param->_have_port_queue_ptr)
+  if (_param->_have_port_ifetch_queue_ptr)
   INSTANCE_SC_SIGNAL (_Ifetch_unit, in_ICACHE_RSP_PACKET_ID               );
   INSTANCE1_SC_SIGNAL(_Ifetch_unit, in_ICACHE_RSP_INSTRUCTION             ,_param->_nb_instruction);
@@ -124,8 +136,8 @@
   INSTANCE_SC_SIGNAL (_Ifetch_unit, in_PREDICT_PC_NEXT_IS_DS_TAKE         );
   INSTANCE1_SC_SIGNAL(_Ifetch_unit, in_PREDICT_INSTRUCTION_ENABLE         ,_param->_nb_instruction);
-  if (_param->_have_port_instruction_ptr)
+  if (_param->_have_port_inst_ifetch_ptr)
   INSTANCE_SC_SIGNAL (_Ifetch_unit, in_PREDICT_INST_IFETCH_PTR            );
   INSTANCE_SC_SIGNAL (_Ifetch_unit, in_PREDICT_BRANCH_STATE               );
-  if (_param->_have_port_branch_update_prediction_id)
+  if (_param->_have_port_depth)
   INSTANCE_SC_SIGNAL (_Ifetch_unit, in_PREDICT_BRANCH_UPDATE_PREDICTION_ID);
   INSTANCE1_SC_SIGNAL(_Ifetch_unit,out_DECOD_VAL                          ,_param->_nb_instruction);
@@ -134,8 +146,8 @@
 //INSTANCE_SC_SIGNAL (_Ifetch_unit,out_DECOD_CONTEXT_ID                   );
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_DECOD_ADDRESS                      );
-  if (_param->_have_port_instruction_ptr)
+  if (_param->_have_port_inst_ifetch_ptr)
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_DECOD_INST_IFETCH_PTR              );
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_DECOD_BRANCH_STATE                 );
-  if (_param->_have_port_branch_update_prediction_id)
+  if (_param->_have_port_depth)
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_DECOD_BRANCH_UPDATE_PREDICTION_ID  );
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_DECOD_EXCEPTION                    );
@@ -143,4 +155,7 @@
   INSTANCE_SC_SIGNAL (_Ifetch_unit,out_EVENT_ACK                          );
   INSTANCE_SC_SIGNAL (_Ifetch_unit, in_EVENT_ADDRESS                      );
+  INSTANCE_SC_SIGNAL (_Ifetch_unit, in_EVENT_ADDRESS_NEXT                 );
+  INSTANCE_SC_SIGNAL (_Ifetch_unit, in_EVENT_ADDRESS_NEXT_VAL             );
+  INSTANCE_SC_SIGNAL (_Ifetch_unit, in_EVENT_IS_DS_TAKE                   );
 
   msg(_("<%s> : Start Simulation ............\n"),name.c_str());
@@ -178,7 +193,7 @@
   Tcontrol_t      nn_val  = false;
 
-  Tgeneral_data_t c_addr  = 0x100;
-  Tgeneral_data_t n_addr  = 0x100;
-  Tgeneral_data_t nn_addr = 0x100;
+  Tgeneral_data_t c_addr  = 0x100>>2;
+  Tgeneral_data_t n_addr  = 0x100>>2;
+  Tgeneral_data_t nn_addr = 0x100>>2;
 
   Tcontrol_t      c_enable [_param->_nb_instruction];
@@ -218,12 +233,12 @@
     TEST(Tcontrol_t,out_DECOD_VAL [i]->read(), 0);
 
-  LABEL("Send Reset");
-  do 
-    {
-      in_EVENT_VAL    ->write(1);
-      in_EVENT_ADDRESS->write(n_addr);
-      SC_START(1);  
-    } while (out_EVENT_ACK->read() == false);
-  in_EVENT_VAL    ->write(0);
+//   LABEL("Send Reset");
+//   do 
+//     {
+//       in_EVENT_VAL    ->write(1);
+//       in_EVENT_ADDRESS->write(n_addr);
+//       SC_START(1);  
+//     } while (out_EVENT_ACK->read() == false);
+//   in_EVENT_VAL    ->write(0);
 
   n_val = 1;
@@ -270,6 +285,10 @@
 
       // EVENT
-      in_EVENT_VAL    ->write((rand()%100)<percent_transaction_event  );
-      in_EVENT_ADDRESS->write(0x100);
+      in_EVENT_VAL             ->write((rand()%100)<percent_transaction_event  );
+      in_EVENT_ADDRESS         ->write(0x77);
+      in_EVENT_ADDRESS_NEXT    ->write(0x171);
+      Tcontrol_t is_ds_take = rand();
+      in_EVENT_ADDRESS_NEXT_VAL->write(is_ds_take);
+      in_EVENT_IS_DS_TAKE      ->write(is_ds_take);
 
       // ICACHE_REQ
@@ -305,5 +324,5 @@
 	  LABEL("ICACHE_REQ : Transaction accepted");
 
-	  Tpacket_t  packet  = (_param->_have_port_queue_ptr)?out_ICACHE_REQ_PACKET_ID->read():0;
+	  Tpacket_t  packet  = (_param->_have_port_ifetch_queue_ptr)?out_ICACHE_REQ_PACKET_ID->read():0;
 	  Taddress_t address = out_ICACHE_REQ_ADDRESS->read();
 
@@ -344,8 +363,8 @@
 	if (find)
 	  {
-	    if (_param->_have_port_instruction_ptr)
+	    if (_param->_have_port_inst_ifetch_ptr)
 	    TEST(Tinst_ifetch_ptr_t, out_DECOD_INST_IFETCH_PTR            ->read(), 0);
 	    TEST(Tbranch_state_t   , out_DECOD_BRANCH_STATE               ->read(), 0);
-	    if (_param->_have_port_branch_update_prediction_id)
+	    if (_param->_have_port_depth)
 	    TEST(Tprediction_ptr_t , out_DECOD_BRANCH_UPDATE_PREDICTION_ID->read(), 0);
 	    TEST(Texception_t      , out_DECOD_EXCEPTION                  ->read(), 0);
@@ -404,8 +423,10 @@
 	  c_val           = false;
 	  n_val           = true;
-	  nn_val          = false;
-
-	  n_addr         = in_EVENT_ADDRESS->read();
-	  n_is_ds_take   = 0;
+
+	  n_addr          = in_EVENT_ADDRESS->read();
+	  n_is_ds_take    = in_EVENT_IS_DS_TAKE->read();
+	  nn_val          = in_EVENT_ADDRESS_NEXT_VAL->read();
+	  nn_addr         = in_EVENT_ADDRESS_NEXT    ->read();
+          nn_is_ds_take   = 0;
 
 	  n_enable [0] = 1;
@@ -496,4 +517,7 @@
   delete    out_EVENT_ACK                           ;
   delete     in_EVENT_ADDRESS                       ;
+  delete     in_EVENT_ADDRESS_NEXT                  ;
+  delete     in_EVENT_ADDRESS_NEXT_VAL              ;
+  delete     in_EVENT_IS_DS_TAKE                    ;
 
   delete    param_cache;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/include/Ifetch_unit.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/include/Ifetch_unit.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/include/Ifetch_unit.h	(revision 88)
@@ -109,4 +109,7 @@
   public    : SC_OUT(Tcontrol_t        )    * out_EVENT_ACK                           ;
   public    : SC_IN (Tgeneral_address_t)    *  in_EVENT_ADDRESS                       ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_EVENT_ADDRESS_NEXT                  ;
+  public    : SC_IN (Tcontrol_t        )    *  in_EVENT_ADDRESS_NEXT_VAL              ;
+  public    : SC_IN (Tcontrol_t        )    *  in_EVENT_IS_DS_TAKE                    ;
     
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/include/Parameters.h	(revision 88)
@@ -28,13 +28,13 @@
   public : uint32_t _size_queue                   ;
   public : uint32_t _nb_instruction               ;
-  public : uint32_t _size_address                 ;
-  public : uint32_t _size_branch_update_prediction;
-
-  public : uint32_t _size_queue_ptr                       ;
-  public : uint32_t _size_instruction_ptr                 ;
-
-  public : bool     _have_port_queue_ptr                  ;
-  public : bool     _have_port_instruction_ptr            ;
-  public : bool     _have_port_branch_update_prediction_id;
+//public : uint32_t _size_address                 ;
+//public : uint32_t _size_branch_update_prediction;
+//
+//public : uint32_t _size_queue_ptr                       ;
+//public : uint32_t _size_instruction_ptr                 ;
+//
+//public : bool     _have_port_queue_ptr                  ;
+//public : bool     _have_port_instruction_ptr            ;
+//public : bool     _have_port_branch_update_prediction_id;
 
   public :morpheo::behavioural::core::multi_front_end::front_end::ifetch_unit::address_management::Parameters * _param_address_management;
@@ -46,7 +46,11 @@
 			uint32_t nb_instruction               ,
 			uint32_t size_branch_update_prediction,
-			uint32_t size_address                 );
+			uint32_t size_address                 ,
+                        bool     is_toplevel=false
+                        );
 //   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit.cpp	(revision 88)
@@ -37,4 +37,10 @@
     log_printf(FUNC,Ifetch_unit,FUNCTION,"Begin");
 
+#if DEBUG_Ifetch_unit == true
+    log_printf(INFO,Ifetch_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     log_printf(INFO,Ifetch_unit,FUNCTION,"Allocation");
 
@@ -46,5 +52,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {	
 	log_printf(INFO,Ifetch_unit,FUNCTION,"Allocation of statistics");
@@ -55,5 +61,5 @@
 
 #ifdef VHDL
-    if (_usage & USE_VHDL)
+    if (usage_is_set(_usage,USE_VHDL))
       {
 	// generate the vhdl
@@ -65,5 +71,5 @@
 
 #ifdef SYSTEMC
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	log_printf(INFO,Ifetch_unit,FUNCTION,"Method - transition");
@@ -89,5 +95,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {
 	statistics_deallocation();
